-- MySQL Script generated by MySQL Workbench
-- Wed Nov 25 09:40:32 2020
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema eusystem
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema eusystem
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `eusystem` DEFAULT CHARACTER SET utf8 ;
USE `eusystem` ;

-- -----------------------------------------------------
-- Table `eusystem`.`Access`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Access` (
  `idAccess` INT NOT NULL AUTO_INCREMENT,
  `TypeOfAccess` VARCHAR(45) NOT NULL,
  `Description` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idAccess`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `eusystem`.`Employee`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Employee` (
  `idEmployee` INT NOT NULL AUTO_INCREMENT,
  `Name` VARCHAR(45) NOT NULL,
  `Surname` VARCHAR(45) NOT NULL,
  `Fname` VARCHAR(45) NOT NULL,
  `Email` VARCHAR(45) NOT NULL,
  `Access_idAccess` INT NOT NULL,
  `Login` VARCHAR(45) NOT NULL,
  `Password` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idEmployee`),
  CONSTRAINT `fk_Employee_Access`
    FOREIGN KEY (`Access_idAccess`)
    REFERENCES `eusystem`.`Access` (`idAccess`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `fk_Employee_Access_idx` ON `eusystem`.`Employee` (`Access_idAccess` ASC) VISIBLE;


-- -----------------------------------------------------
-- Table `eusystem`.`Developer`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Developer` (
  `idDeveloper` INT NOT NULL AUTO_INCREMENT,
  `Developer` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idDeveloper`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `eusystem`.`Type`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Type` (
  `idType` INT NOT NULL AUTO_INCREMENT,
  `Type` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idType`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `eusystem`.`Equipment`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Equipment` (
  `idEquipment` INT NOT NULL AUTO_INCREMENT,
  `Model` VARCHAR(45) NOT NULL,
  `ReleaseDate` DATE NOT NULL,
  `inStock` TINYINT NOT NULL,
  `Developer_idDeveloper` INT NOT NULL,
  `Type_idType` INT NOT NULL,
  PRIMARY KEY (`idEquipment`),
  CONSTRAINT `fk_Equipment_Developer1`
    FOREIGN KEY (`Developer_idDeveloper`)
    REFERENCES `eusystem`.`Developer` (`idDeveloper`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Equipment_Type1`
    FOREIGN KEY (`Type_idType`)
    REFERENCES `eusystem`.`Type` (`idType`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `fk_Equipment_Developer1_idx` ON `eusystem`.`Equipment` (`Developer_idDeveloper` ASC) VISIBLE;

CREATE INDEX `fk_Equipment_Type1_idx` ON `eusystem`.`Equipment` (`Type_idType` ASC) VISIBLE;


-- -----------------------------------------------------
-- Table `eusystem`.`Status`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Status` (
  `idStatus` INT NOT NULL AUTO_INCREMENT,
  `Status` VARCHAR(45) NOT NULL,
  `Description` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`idStatus`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `eusystem`.`Application`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Application` (
  `Employee_idEmployee` INT NOT NULL,
  `Equipment_idEquipment` INT NULL,
  `ApplicationID` INT NOT NULL AUTO_INCREMENT,
  `StartDate` DATE NOT NULL,
  `EndDate` DATE NULL,
  `Status_idStatus` INT NOT NULL,
  `Reason` VARCHAR(255) NULL,
  `OldType` VARCHAR(45) NOT NULL,
  `OldModel` VARCHAR(45) NOT NULL,
  `OldDeveloper` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`ApplicationID`),
  CONSTRAINT `fk_Employee_has_Equipment_Employee1`
    FOREIGN KEY (`Employee_idEmployee`)
    REFERENCES `eusystem`.`Employee` (`idEmployee`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Employee_has_Equipment_Equipment1`
    FOREIGN KEY (`Equipment_idEquipment`)
    REFERENCES `eusystem`.`Equipment` (`idEquipment`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Application_Status1`
    FOREIGN KEY (`Status_idStatus`)
    REFERENCES `eusystem`.`Status` (`idStatus`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `fk_Employee_has_Equipment_Equipment1_idx` ON `eusystem`.`Application` (`Equipment_idEquipment` ASC) VISIBLE;

CREATE INDEX `fk_Employee_has_Equipment_Employee1_idx` ON `eusystem`.`Application` (`Employee_idEmployee` ASC) VISIBLE;

CREATE INDEX `fk_Application_Status1_idx` ON `eusystem`.`Application` (`Status_idStatus` ASC) VISIBLE;


-- -----------------------------------------------------
-- Table `eusystem`.`Qanda`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`Qanda` (
  `idFaq` INT NOT NULL AUTO_INCREMENT,
  `QText` VARCHAR(255) NOT NULL,
  `AText` VARCHAR(255) NULL,
  PRIMARY KEY (`idFaq`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `eusystem`.`EmpsQst`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `eusystem`.`EmpsQst` (
  `Faq_idFaq` INT NOT NULL,
  `Employee_idEmployee` INT NOT NULL,
  PRIMARY KEY (`Faq_idFaq`, `Employee_idEmployee`),
  CONSTRAINT `fk_Faq_has_Employee_Faq1`
    FOREIGN KEY (`Faq_idFaq`)
    REFERENCES `eusystem`.`Qanda` (`idFaq`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Faq_has_Employee_Employee1`
    FOREIGN KEY (`Employee_idEmployee`)
    REFERENCES `eusystem`.`Employee` (`idEmployee`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `fk_Faq_has_Employee_Employee1_idx` ON `eusystem`.`EmpsQst` (`Employee_idEmployee` ASC) VISIBLE;

CREATE INDEX `fk_Faq_has_Employee_Faq1_idx` ON `eusystem`.`EmpsQst` (`Faq_idFaq` ASC) VISIBLE;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;

--INSERTS
INSERT INTO `eusystem`.`access`
(`idAccess`,
`TypeOfAccess`,
`Description`)
VALUES
(1,
'Admin',
'Admin of system'),
(2,
'User',
'User of system'),
(3,
'Sysadmin',
'System admin of system');
INSERT INTO `eusystem`.`employee`
(`idEmployee`,
`Name`,
`Surname`,
`Fname`,
`Email`,
`Access_idAccess`,
`Login`,
`Password`)
VALUES
(1,
'Ivan',
'Ivanov',
'Ivanovich',
'admin@dubna.ru',
1,
'admin',
'adm777'),
(2,
'Vasiliy',
'Vasilev',
'Vasilyevich',
'vvv@dubna.ru',
2,
'user1',
'usr111'),
(3,
'Konstantin',
'Konstantinov',
'Konstantinovich',
'kkk@dubna.ru',
3,
'sysadmin',
'sysadm777');
